<script lang="ts">
  import { onMount } from 'svelte';

  export let phrase = ''; // text to be typed
  export let index = 0; // start index of the phrase to start typing
  export let speed = 100; //speed text should be typed
  export let cursor = '█'; //cursor text also consider "_", "⠀", "▯", or "█"
  let clazz = '';
  export { clazz as class };

  // Allow the first characters to be displayed
  let displayText = phrase.length ? phrase.slice(0, index) : '';
  let typewriter; // control interval timer

  $: if (!phrase) {
    displayText = '';
    index = displayText.length;
  }

  function typeChar() {
    if (index < phrase.length) {
      displayText += phrase[index];
      index += 1;
    } else {
      stopTyping();
      return;
    }
  }

  function startTyping() {
    typewriter = setInterval(typeChar, speed);
  }

  function stopTyping() {
    clearInterval(typewriter);
  }

  onMount(startTyping);
</script>

<div class="typewriter {clazz}">
  {displayText}
  <span class="cursor">{cursor}</span>
</div>

<style>
  @keyframes blink {
    0% {
      color: transparent;
    }
    to {
      color: #faca15;
    }
  }

  .cursor {
    animation: blink 0.8s infinite;
  }
</style>
